﻿// dllmain.cpp : Определяет точку входа для приложения DLL.
#include "pch.h"
#include "unknown.h"
#include "sdk/apiPlugin.h"
#include "task.h"

constexpr wchar_t Name[] = L"AIMPTaskCpp";
constexpr wchar_t Author[] = L"Append";
constexpr wchar_t Description[] = L"Test AIMP Task";

static void WINAPI HiArtem(IAIMPTaskOwner* owner)
{
	MessageBox(nullptr, L"Hi Artem from func", nullptr, 0);
	if (owner->IsCanceled()) return;
}

TaskFunc HiArtemFromLambda = [](IAIMPTaskOwner* owner)
{
	MessageBox(nullptr, L"Hi Artem from lambda", nullptr, 0);
	if (owner->IsCanceled()) return;
};

class Plugin : public UnknownII<IAIMPPlugin>
{
public:
	Plugin()
	{
		AddRef();
	}
private:

	virtual PWCHAR WINAPI InfoGet(int index) override
	{
		switch (index)
		{
		case AIMP_PLUGIN_INFO_AUTHOR:
			return const_cast<PWCHAR>(Author);
		case AIMP_PLUGIN_INFO_NAME:
			return const_cast<PWCHAR>(Name);
		case AIMP_PLUGIN_INFO_SHORT_DESCRIPTION:
			return const_cast<PWCHAR>(Description);
		default:
			return nullptr;
		}
	}
	virtual DWORD WINAPI InfoGetCategories() override
	{
		return AIMP_PLUGIN_CATEGORY_ADDONS;;
	}
	virtual HRESULT WINAPI Initialize(IAIMPCore* core) override
	{
		IAIMPServiceSynchronizer* sync = nullptr;
		core->QueryInterface(IID_IAIMPServiceSynchronizer, reinterpret_cast<void**>(&sync));
		sync->ExecuteInMainThread(new Task(nullptr), false);
		sync->ExecuteInMainThread(new Task(HiArtem), false);
		sync->ExecuteInMainThread(new Task(HiArtemFromLambda), false);
		sync->Release();

		return S_OK;
	}
	virtual HRESULT WINAPI Finalize() override
	{
		return S_OK;
	}
	virtual void WINAPI SystemNotification(int NotifyID, IUnknown* Data) override
	{
	}
};

HRESULT WINAPI AIMPPluginGetHeader(IAIMPPlugin** plugin)
{
	*plugin = new Plugin();
	return S_OK;
}

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
                     )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }
    return TRUE;
}

