#include "pch.h"
#include "task.h"

Task::Task(TaskFunc calledFunc)
	: _func(calledFunc)
{
}

Task::~Task()
{
	_func = nullptr;
}

HRESULT WINAPI Task::QueryInterface(REFIID riid, LPVOID* ppvObj)
{
	return Base::QueryInterface(riid, ppvObj);
}

ULONG WINAPI Task::AddRef(void)
{
	return Base::AddRef();
}

ULONG WINAPI Task::Release(void)
{
	return Base::Release();
}

void WINAPI Task::Execute(IAIMPTaskOwner* owner)
{
	if (owner->IsCanceled()) return;
	if (_func)
		_func(owner);
}

int WINAPI Task::GetPriority()
{
	return AIMP_TASK_PRIORITY_NORMAL;
}
