#pragma once
#include "unknown.h"
#include <functional>
#include "sdk/apiThreading.h"

//using TaskFunc =  void(__stdcall*)(IAIMPTaskOwner*);
using TaskFunc = std::function<void(IAIMPTaskOwner*)>;

class Task
	: public UnknownII<IAIMPTask>
	, public IAIMPTaskPriority
{
public:
	using Base = UnknownII<IAIMPTask>;
	Task(TaskFunc calledFunc);
	~Task();

	HRESULT WINAPI QueryInterface(REFIID riid, LPVOID* ppvObj);
	ULONG WINAPI AddRef(void) override;
	ULONG WINAPI Release(void) override;

	void WINAPI Execute(IAIMPTaskOwner* owner) override;
	int WINAPI GetPriority() override;
private:
	TaskFunc _func;

};
