#pragma once
#include <Unknwn.h>

template<typename T>
class UnknownII : public T
{
public:
	UnknownII() : _count(0) {}
	virtual ~UnknownII() {}

	virtual HRESULT WINAPI QueryInterface(REFIID riid, LPVOID* ppvObj)
	{
		if (!ppvObj) return E_POINTER;

		if (riid == IID_IUnknown)
		{
			*ppvObj = this;
			AddRef();
			return S_OK;
		}

		*ppvObj = nullptr;
		return E_NOINTERFACE;
	}

	virtual ULONG WINAPI AddRef(void)
	{
		return ++_count;
	}

	virtual ULONG WINAPI Release(void)
	{
		auto tmp = --_count;

		if (tmp == 0)
			delete this;

		return tmp;
	}

private:
	ULONG _count;
};